#Section 1: Setup
# Importing Packages---------------------------------------------------------
# INSERT CODE HERE

# GPIO Setup
GPIO.setwarnings(False)

# INSERT CODE HERE - Set variable for servoPin
# INSERT CODE HERE - Set GPIO mode to GPIO.BCM
# INSERT CODE HERE - Set servoPin as GPIO.OUT
pwm = GPIO.PWM(servoPin, 100) 

#------------------------------------------------------------------------------------------------
#SECTION 2: Pi Camera Setup
  # INSERT CODE: Make a camera object
  # INSERT CODE: Set camera resolution
  # INSERT CODE: Set image format
  # INSERT CODE: Set camera frame rate
  # INSERT CODE: Set the camera to the "preview" configuration
  # INSERT CODE: Start the camera

#------------------------------------------------------------------------------------------------
#SECTION 3: Image Processing
while(True):
    frame = camera.capture_array()
    hsvFrame=cv2.cvtColor(frame,cv2.COLOR_BGR2HSV)   #Convert from BGR to HSV

    red_lower = np.array([160,70,50]) #Define boundaries for Red
    red_upper = np.array([180, 255, 255])
    red_mask = cv2.inRange(hsvFrame, red_lower, red_upper)   #Threshold HSV image to identify only Red
    result_red= cv2.bitwise_and(frame,frame, mask=red_mask) #Bitwise-AND original image with mask

   #Green Color Detection:   
   # INSERT CODE: Define green lower boundary
   # INSERT CODE: Define green upper boundary
   # INSERT CODE: Create green mask
   # INSERT CODE: Use bitwise_and to isolate green color from the video

   #Result:
   # INSERT CODE: Combine the results so both red and green colors are isolated from the video

   # INSERT CODE: Display the final result
  
    #SECTION 4: Servo Control with Color Detection----------------------------------------------------
#when q is pressed, the image seen is checked for red and green presence. cv2.waitKey(5) makes the frame pause for 5 ms
    if cv2.waitKey(5) & 0xFF == ord('q'):
      camera.close()
      if(cv2.countNonZero(red_mask)>cv2.countNonZero(green_mask)) and cv2.countNonZero(red_mask)>(0.25*640*480):
        print('Red detected')
        #INSERT CODE: Start clockwise rotation; dutycycle = 5
        
      elif #INSERT CONDITIONS HERE: (The frame should have more green pixels than red, and at least 25% of the pixels should be green):
        print('Green detected')
        #INSERT CODE: Start counterclockwise rotation; dutycycle = 55
    
      else:
        print('Neither red nor green detected')
        #INSERT CODE: Stop servo rotation
        
      print('------------------------')

GPIO.cleanup()
